package com.zlockwindow;

import android.app.*;
import android.app.admin.*;
import android.content.*;
import android.graphics.*;
import android.os.*;
import android.view.*;
import android.view.View.*;
import android.view.WindowManager.*;
import android.widget.*;
import java.io.*;
import com.zlockwindow.Receiver.*;

public class LockWMService extends Service
{
	private method me;
	private LinearLayout mFloatLayout;
    private WindowManager.LayoutParams wmParams;
   	private WindowManager mWindowManager;
	private LinearLayout l;
	private TextView mTextView;
	private boolean move;
	private int width,x,y,traffic_backgroundalpha,traffic_size;
	private DevicePolicyManager policyManager; 
	private ComponentName componentName;
	private String mtext,traffic_text_color;
	
	@Override
	public IBinder onBind(Intent p1)
	{
		return null;
	}

	@Override
	public void onCreate()
	{
		super.onCreate();
		init();
		initView();
	}
	
	private void init(){
		me=new method(this);
		width=me.getint("width",1080);
		traffic_size=Integer.valueOf(me.getString("lock_size","20")).intValue();
		traffic_backgroundalpha=Integer.valueOf(me.getString("lock_backgroundalpha","00")).intValue();
		mtext=me.getString("lock_text","○");
		traffic_text_color=me.getString("lock_text_color","#FFFFFF");
	}
	
	private void initView(){
		wmParams = new WindowManager.LayoutParams();  
        mWindowManager = (WindowManager)getApplication().getSystemService(getApplication().WINDOW_SERVICE);  
        wmParams.type = LayoutParams.TYPE_SYSTEM_ERROR;   
        wmParams.format = PixelFormat.RGBA_8888;   
        wmParams.flags = LayoutParams.FLAG_NOT_FOCUSABLE|LayoutParams.FLAG_FULLSCREEN| LayoutParams.FLAG_LAYOUT_IN_SCREEN;
		wmParams.gravity = Gravity.LEFT | Gravity.TOP;
		wmParams.x = me.getint("lock_sp_x",0);
        wmParams.y = me.getint("lock_sp_y",0);
        wmParams.width = WindowManager.LayoutParams.WRAP_CONTENT;  
        wmParams.height = WindowManager.LayoutParams.WRAP_CONTENT;  
		LayoutInflater inflater = LayoutInflater.from(getApplication());  
        mFloatLayout = (LinearLayout) inflater.inflate(R.layout.lock_windows, null);  
        mWindowManager.addView(mFloatLayout, wmParams);  
		mFloatLayout.measure(View.MeasureSpec.makeMeasureSpec(0,View.MeasureSpec.UNSPECIFIED), View.MeasureSpec  .makeMeasureSpec(0, View.MeasureSpec.UNSPECIFIED)); 
		l=(LinearLayout)mFloatLayout.findViewById(R.id.TrafficServiceLinearLayout1);
		l.setBackgroundColor(Color.argb(traffic_backgroundalpha,0,0,0));
		mTextView=(TextView)mFloatLayout.findViewById(R.id.floatlayoutTextView1);
		mTextView.setTextSize(traffic_size);
		mTextView.setText(mtext);
		mTextView.setTextColor(Color.parseColor(traffic_text_color));
		l.setOnTouchListener(new OnTouchListener()   
			{  
				@Override
				public boolean onTouch(View v, MotionEvent event)   
				{
					if(event.getAction()==event.ACTION_DOWN){
						x=(int)event.getX();
						y=(int)event.getY();
					}else if(event.getAction()==event.ACTION_MOVE){
						if(move){
							wmParams.x = (int)event.getRawX()- l.getMeasuredWidth() / 2 ;
							wmParams.y = (int)event.getRawY() - l.getMeasuredHeight() / 2 - 25;
							mWindowManager.updateViewLayout(mFloatLayout, wmParams);
						}
					}else if(event.getAction()==event.ACTION_UP){
						x=x-(int)event.getX();
						y=y-(int)event.getY();
						me.editint("lock_sp_x",wmParams.x);
						me.editint("lock_sp_y",wmParams.y);
						l.setBackgroundColor(Color.argb(traffic_backgroundalpha,0,0,0));
						move=false;
					}
					return false;
				}
			});
		l.setOnClickListener(new OnClickListener(){
				@Override
				public void onClick(View p1)
				{
					new Handler().postDelayed(new Runnable(){
							@Override
							public void run()
							{
								if(!move){
									/*if(me.catString(me.getString("lock_icon","风格1"),"风格1")){
										event(1);
									}else if(me.catString(me.getString("lock_icon","风格2"),"风格2")){
										event(2);
									}else if(me.catString(me.getString("lock_icon","风格3"),"风格3")){
										event(3);
									}else if(me.catString(me.getString("lock_icon","自定义文本"),"自定义文本")){
										lock();
									}*/
									lock();
								}
							}
					},200);
				}
			});
		l.setOnLongClickListener(new OnLongClickListener(){
				@Override
				public boolean onLongClick(View p1)
				{
					move=true;
					l.setBackgroundColor(Color.argb(traffic_backgroundalpha+50,0,0,0));
					me.showToast(LockWMService.this,"解除移动！");
					return false;
				}
		});
	}
	
	private void lock(){
		policyManager = (DevicePolicyManager) getSystemService(Context.DEVICE_POLICY_SERVICE);
        componentName = new ComponentName(this,LockReceiver.class);
        if (policyManager.isAdminActive(componentName)) {
            policyManager.lockNow();
        }else{
			me.showToast(this,"没有获取到设备管理器权限！");
			Intent in= new Intent(LockWMService.this,MainActivity.class);
			in.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
			startActivity(in);
        }
	}
	
	private void event(int i){
		switch(i){
			case 1:
				break;
			case 2:
				break;
			case 3:
/*				Intent in= new Intent(Intent.ACTION_MAIN);
				in.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
				in.addCategory(Intent.CATEGORY_HOME);
				startActivity(in);
				*/
				break;
		}
		
	}
	
	@Override
	public void onDestroy()
	{
		super.onDestroy();
		if(mFloatLayout != null)  
        {  
            mWindowManager.removeView(mFloatLayout);
        }
	}

}
