package com.zlockwindow;

import android.app.admin.*;
import android.content.*;
import android.os.*;
import android.preference.*;
import android.preference.Preference.*;
import android.util.*;
import com.zlockwindow.Receiver.*;


public class MainActivity extends PreferenceActivity implements OnPreferenceChangeListener
{
	private method me;
	private static final String s="Frast_1.0";
	private DisplayMetrics metric;
	private ListPreference traffic_icon;
	private PreferenceCategory traffic_xfc;
	private CheckBoxPreference traffic,sbglq;
	private DevicePolicyManager policyManager; 
	private ComponentName componentName;
	private EditTextPreference traffic_text,traffic_text_color;

    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        addPreferencesFromResource(R.xml.lockwindow);
		init();
	}

	public void init(){
		me=new method(this);
		traffic_xfc=(PreferenceCategory)findPreference("lock_xfc");
		traffic=(CheckBoxPreference) findPreference("lock");
		traffic_icon=(ListPreference)findPreference("lock_icon");
		sbglq=(CheckBoxPreference)findPreference("sbglq");
		traffic_text=(EditTextPreference)findPreference("lock_text");
		traffic_text_color=(EditTextPreference)findPreference("lock_text_color");
		metric = new DisplayMetrics();
		getWindowManager().getDefaultDisplay().getMetrics(metric);
		if(!me.getBoolean(s,false)){
			me.editBoolean(s,true);
			me.editint("width",metric.widthPixels);
			me.editint("height",metric.heightPixels);
		}
		if(!me.getBoolean("lock",false)){
			traffic_xfc.setEnabled(false);
		}
		if(!me.catString(me.getString("lock_icon","自定义文本"),"自定义文本")){
			traffic_text.setEnabled(true);
		}
		traffic_icon.setOnPreferenceChangeListener(this);
		traffic.setOnPreferenceChangeListener(this);
		sbglq.setOnPreferenceChangeListener(this);
		traffic_text_color.setOnPreferenceChangeListener(this);
		traffic_text.setOnPreferenceChangeListener(this);
	}

	@Override
	public boolean onPreferenceChange(Preference p1, Object p2)
	{
		String p=p1.getKey();
		switch(p){
			case "lock":
				if(me.getBoolean(p,true)){
					traffic.setChecked(false);
					traffic_xfc.setEnabled(false);
					stopService(new Intent(this,LockWMService.class));
				}else{
					traffic.setChecked(true);
					traffic_xfc.setEnabled(true);
					startService(new Intent(this,LockWMService.class));
				}
				break;
			case "lock_icon":
				traffic_icon.setValue(p2.toString());
				traffic_icon.setSummary(p2.toString());
				if(me.catString(me.getString("lock_icon","自定义文本"),"自定义文本")){
					traffic_text.setEnabled(true);
				}else if(me.catString(me.getString("lock_icon","风格1"),"风格1")){
					me.editString("lock_text","🔒");
					traffic_text.setEnabled(false);
				}else if(me.catString(me.getString("lock_icon","风格2"),"风格2")){
					me.editString("lock_text","🚀");
					traffic_text.setEnabled(false);
				}else if(me.catString(me.getString("lock_icon","风格3"),"风格3")){
					me.editString("lock_text","●");
					traffic_text.setEnabled(false);
				}
				trafficservice();
				break;
			case "sbglq":
				lock();
				break;
			case "lock_text":
				traffic_text.setSummary(me.getString("lock_text","🔒"));
				me.editString(p1.getKey(),p2.toString());
				trafficservice();
				break;
			case "lock_text_color":
				me.editString(p1.getKey(),p2.toString());
				trafficservice();
				break;
		}
		return false;
	}


	private void trafficservice(){
		stopService(new Intent(this,LockWMService.class));
		new Handler().postDelayed(new Runnable(){
				@Override
				public void run()
				{
					startService(new Intent(MainActivity.this,LockWMService.class));
				}
			},500);
	}

	private void lock(){
		policyManager = (DevicePolicyManager) getSystemService(Context.DEVICE_POLICY_SERVICE);
        componentName = new ComponentName(this,LockReceiver.class);
        if (policyManager.isAdminActive(componentName)){
			me.editBoolean("sbglq",true);
			sbglq.setEnabled(false);
			sbglq.setSummary("已获取");
        }else{
            activeManager();
        }
	}

	private void activeManager() { 
        Intent intent = new Intent(DevicePolicyManager.ACTION_ADD_DEVICE_ADMIN); 
        intent.putExtra(DevicePolicyManager.EXTRA_DEVICE_ADMIN, componentName); 
        intent.putExtra(DevicePolicyManager.EXTRA_ADD_EXPLANATION, "一键锁屏"); 
        startActivity(intent); 
    }

	@Override
	protected void onStart()
	{
		super.onStart();
		if(me.getBoolean("sbglq",false)){
			sbglq.setEnabled(false);
		}
	}
}

